'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = Canvas;

var _mixin = require('./util/mixin');

var Mixin = _interopRequireWildcard(_mixin);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

// import HTMLCanvasElement from './HTMLCanvasElement'

// TODO
var hasModifiedCanvasPrototype = false; /* eslint-disable */

var hasInit2DContextConstructor = false;
var hasInitWebGLContextConstructor = false;

function Canvas() {
    var canvas = swan.createCanvas();

    var _getContext = canvas.getContext;

    // canvas.__proto__.__proto__.__proto__ = new HTMLCanvasElement()

    if (!('tagName' in canvas)) {
        canvas.tagName = 'CANVAS';
    }

    canvas.type = 'canvas';

    Mixin.parentNode(canvas);
    Mixin.style(canvas);
    Mixin.classList(canvas);
    Mixin.clientRegion(canvas);
    Mixin.offsetRegion(canvas);

    canvas.focus = function () {};
    canvas.blur = function () {};

    canvas.addEventListener = function (type, listener) {
        var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

        // console.log('canvas.addEventListener', type);
        document.addEventListener(type, listener, options);
    };

    canvas.removeEventListener = function (type, listener) {
        // console.log('canvas.removeEventListener', type);
        document.removeEventListener(type, listener);
    };

    canvas.dispatchEvent = function () {
        var event = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

        console.log('canvas.dispatchEvent', event.type, event);
        // nothing to do
    };

    return canvas;
}
module.exports = exports['default'];