'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = undefined;

var _index = require('./util/index.js');

var _mixin = require('./util/mixin');

var Mixin = _interopRequireWildcard(_mixin);

var _Element2 = require('./Element');

var _Element3 = _interopRequireDefault(_Element2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /* eslint-disable */


var HTMLElement = function (_Element) {
    _inherits(HTMLElement, _Element);

    function HTMLElement() {
        var tagName = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
        var level = arguments[1];

        _classCallCheck(this, HTMLElement);

        var _this = _possibleConstructorReturn(this, (HTMLElement.__proto__ || Object.getPrototypeOf(HTMLElement)).call(this));

        _this.className = '';
        _this.childern = [];

        _this.focus = _index.noop;
        _this.blur = _index.noop;

        _this.insertBefore = _index.noop;
        _this.appendChild = _index.noop;
        _this.removeChild = _index.noop;
        _this.remove = _index.noop;

        _this.innerHTML = '';

        _this.tagName = tagName.toUpperCase();

        Mixin.parentNode(_this, level);
        Mixin.style(_this);
        Mixin.classList(_this);
        Mixin.clientRegion(_this);
        Mixin.offsetRegion(_this);
        Mixin.scrollRegion(_this);
        return _this;
    }

    return HTMLElement;
}(_Element3.default);

exports.default = HTMLElement;
module.exports = exports['default'];