'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _index = require('./util/index.js');

// TODO 开放域下用 userAgent
var systemInfo = swan.getSystemInfoSync && swan.getSystemInfoSync(); /* eslint-disable */


var system = systemInfo && systemInfo.system || '';
var platform = systemInfo && systemInfo.platform || '';
var language = systemInfo && systemInfo.language || '"zh_CN"';

var android = system.toLowerCase().indexOf('android') !== -1;

var uaDesc = android ? 'Android; CPU Android 6.0' : 'iPhone; CPU iPhone OS 10_3_1 like Mac OS X';
var ua = 'Mozilla/5.0 (' + uaDesc + ') AppleWebKit/603.1.30 (KHTML, like Gecko) Mobile/14E8301 MicroMessenger/6.6.0 SwanGame NetType/WIFI Language/' + language;

var navigator = {
  platform: platform,
  language: language,
  appVersion: '5.0 (' + uaDesc + ') AppleWebKit/601.1.46 (KHTML, like Gecko) Version/9.0 Mobile/13B143 Safari/601.1',
  userAgent: ua,
  onLine: true, // TODO 用 swan.getNetworkStateChange 和 swan.onNetworkStateChange 来返回真实的状态

  // TODO 用 swan.getLocation 来封装 geolocation
  geolocation: {
    getCurrentPosition: _index.noop,
    watchPosition: _index.noop,
    clearWatch: _index.noop
  }
};

if (swan.onNetworkStatusChange) {
  swan.onNetworkStatusChange(function (event) {
    navigator.onLine = event.isConnected;
  });
}

exports.default = navigator;
module.exports = exports['default'];