'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.parentNode = parentNode;
exports.style = style;
exports.clientRegion = clientRegion;
exports.offsetRegion = offsetRegion;
exports.scrollRegion = scrollRegion;
exports.classList = classList;

var _WindowProperties = require('../WindowProperties');

function parentNode(obj, level) {
    if (!('parentNode' in obj)) {
        var _parent = void 0;

        if (level === 0) {
            _parent = function _parent() {
                // return document
                return null;
            };
        } else if (level === 1) {
            _parent = function _parent() {
                return document.documentElement;
            };
        } else {
            _parent = function _parent() {
                return document.body;
            };
        }

        Object.defineProperty(obj, 'parentNode', {
            enumerable: true,
            get: _parent
        });
    }

    if (!('parentElement' in obj)) {
        var _parent2 = void 0;

        if (level === 0) {
            _parent2 = function _parent2() {
                return null;
            };
        } else if (level === 1) {
            _parent2 = function _parent2() {
                return document.documentElement;
            };
        } else {
            _parent2 = function _parent2() {
                return document.body;
            };
        }

        Object.defineProperty(obj, 'parentElement', {
            enumerable: true,
            get: _parent2
        });
    }
} /* eslint-disable */
function style(obj) {
    obj.style = obj.style || {};

    Object.assign(obj.style, {
        top: '0px',
        left: '0px',
        width: _WindowProperties.innerWidth + 'px',
        height: _WindowProperties.innerHeight + 'px',
        margin: '0px',
        padding: '0px',
        removeProperty: function removeProperty() {},
        setProperty: function setProperty() {}
    });
}

function clientRegion(obj) {
    if (!('clientLeft' in obj)) {
        obj.clientLeft = 0;
        obj.clientTop = 0;
    }
    if (!('clientWidth' in obj)) {
        obj.clientWidth = _WindowProperties.innerWidth;
        obj.clientHeight = _WindowProperties.innerHeight;
    }

    if (!('getBoundingClientRect' in obj)) {
        obj.getBoundingClientRect = function () {
            var ret = {
                x: 0,
                y: 0,
                top: 0,
                left: 0,
                width: this.clientWidth,
                height: this.clientHeight
            };
            ret.right = ret.width;
            ret.bottom = ret.height;

            return ret;
        };
    }
}

function offsetRegion(obj) {
    if (!('offsetLeft' in obj)) {
        obj.offsetLeft = 0;
        obj.offsetTop = 0;
    }
    if (!('offsetWidth' in obj)) {
        obj.offsetWidth = _WindowProperties.innerWidth;
        obj.offsetHeight = _WindowProperties.innerHeight;
    }
}

function scrollRegion(obj) {
    if (!('scrollLeft' in obj)) {
        obj.scrollLeft = 0;
        obj.scrollTop = 0;
    }
    if (!('scrollWidth' in obj)) {
        obj.scrollWidth = _WindowProperties.innerWidth;
        obj.scrollHeight = _WindowProperties.innerHeight;
    }
}

function classList(obj) {
    var noop = function noop() {};
    obj.classList = [];
    obj.classList.add = noop;
    obj.classList.remove = noop;
    obj.classList.contains = noop;
    obj.classList.toggle = noop;
}