'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.cancelAnimationFrame = exports.requestAnimationFrame = exports.clearInterval = exports.setInterval = exports.clearTimeout = exports.setTimeout = exports.scrollBy = exports.scrollTo = exports.getComputedStyle = exports.blur = exports.focus = exports.alert = exports.canvas = exports.atob = exports.btoa = exports.location = exports.localStorage = exports.MouseEvent = exports.PointerEvent = exports.TouchEvent = exports.WebGLRenderingContext = exports.HTMLVideoElement = exports.HTMLAudioElement = exports.HTMLMediaElement = exports.HTMLCanvasElement = exports.HTMLImageElement = exports.HTMLElement = exports.Audio = exports.ImageBitmap = exports.Image = exports.Worker = exports.WebSocket = exports.XMLHttpRequest = exports.navigator = undefined;

var _navigator = require('./navigator');

Object.defineProperty(exports, 'navigator', {
    enumerable: true,
    get: function get() {
        return _interopRequireDefault(_navigator).default;
    }
});

var _XMLHttpRequest = require('./XMLHttpRequest');

Object.defineProperty(exports, 'XMLHttpRequest', {
    enumerable: true,
    get: function get() {
        return _interopRequireDefault(_XMLHttpRequest).default;
    }
});

var _WebSocket = require('./WebSocket');

Object.defineProperty(exports, 'WebSocket', {
    enumerable: true,
    get: function get() {
        return _interopRequireDefault(_WebSocket).default;
    }
});

var _Worker = require('./Worker');

Object.defineProperty(exports, 'Worker', {
    enumerable: true,
    get: function get() {
        return _interopRequireDefault(_Worker).default;
    }
});

var _Image = require('./Image');

Object.defineProperty(exports, 'Image', {
    enumerable: true,
    get: function get() {
        return _interopRequireDefault(_Image).default;
    }
});

var _ImageBitmap = require('./ImageBitmap');

Object.defineProperty(exports, 'ImageBitmap', {
    enumerable: true,
    get: function get() {
        return _interopRequireDefault(_ImageBitmap).default;
    }
});

var _Audio = require('./Audio');

Object.defineProperty(exports, 'Audio', {
    enumerable: true,
    get: function get() {
        return _interopRequireDefault(_Audio).default;
    }
});

var _HTMLElement = require('./HTMLElement');

Object.defineProperty(exports, 'HTMLElement', {
    enumerable: true,
    get: function get() {
        return _interopRequireDefault(_HTMLElement).default;
    }
});

var _HTMLImageElement = require('./HTMLImageElement');

Object.defineProperty(exports, 'HTMLImageElement', {
    enumerable: true,
    get: function get() {
        return _interopRequireDefault(_HTMLImageElement).default;
    }
});

var _HTMLCanvasElement = require('./HTMLCanvasElement');

Object.defineProperty(exports, 'HTMLCanvasElement', {
    enumerable: true,
    get: function get() {
        return _interopRequireDefault(_HTMLCanvasElement).default;
    }
});

var _HTMLMediaElement = require('./HTMLMediaElement');

Object.defineProperty(exports, 'HTMLMediaElement', {
    enumerable: true,
    get: function get() {
        return _interopRequireDefault(_HTMLMediaElement).default;
    }
});

var _HTMLAudioElement = require('./HTMLAudioElement');

Object.defineProperty(exports, 'HTMLAudioElement', {
    enumerable: true,
    get: function get() {
        return _interopRequireDefault(_HTMLAudioElement).default;
    }
});

var _HTMLVideoElement = require('./HTMLVideoElement');

Object.defineProperty(exports, 'HTMLVideoElement', {
    enumerable: true,
    get: function get() {
        return _interopRequireDefault(_HTMLVideoElement).default;
    }
});

var _WebGLRenderingContext = require('./WebGLRenderingContext');

Object.defineProperty(exports, 'WebGLRenderingContext', {
    enumerable: true,
    get: function get() {
        return _interopRequireDefault(_WebGLRenderingContext).default;
    }
});

var _index = require('./EventIniter/index.js');

Object.defineProperty(exports, 'TouchEvent', {
    enumerable: true,
    get: function get() {
        return _index.TouchEvent;
    }
});
Object.defineProperty(exports, 'PointerEvent', {
    enumerable: true,
    get: function get() {
        return _index.PointerEvent;
    }
});
Object.defineProperty(exports, 'MouseEvent', {
    enumerable: true,
    get: function get() {
        return _index.MouseEvent;
    }
});

var _localStorage = require('./localStorage');

Object.defineProperty(exports, 'localStorage', {
    enumerable: true,
    get: function get() {
        return _interopRequireDefault(_localStorage).default;
    }
});

var _location = require('./location');

Object.defineProperty(exports, 'location', {
    enumerable: true,
    get: function get() {
        return _interopRequireDefault(_location).default;
    }
});

var _Base = require('./Base64.js');

Object.defineProperty(exports, 'btoa', {
    enumerable: true,
    get: function get() {
        return _Base.btoa;
    }
});
Object.defineProperty(exports, 'atob', {
    enumerable: true,
    get: function get() {
        return _Base.atob;
    }
});

var _WindowProperties = require('./WindowProperties');

Object.keys(_WindowProperties).forEach(function (key) {
    if (key === "default" || key === "__esModule") return;
    Object.defineProperty(exports, key, {
        enumerable: true,
        get: function get() {
            return _WindowProperties[key];
        }
    });
});

var _Canvas = require('./Canvas');

var _Canvas2 = _interopRequireDefault(_Canvas);

var _CommonComputedStyle = require('./style/CommonComputedStyle');

var _CommonComputedStyle2 = _interopRequireDefault(_CommonComputedStyle);

var _ImageComputedStyle = require('./style/ImageComputedStyle');

var _ImageComputedStyle2 = _interopRequireDefault(_ImageComputedStyle);

var _CanvasComputedStyle = require('./style/CanvasComputedStyle');

var _CanvasComputedStyle2 = _interopRequireDefault(_CanvasComputedStyle);

var _Event = require('./Event');

var _Event2 = _interopRequireDefault(_Event);

var _isDevtool = require('./util/isDevtool');

var _isDevtool2 = _interopRequireDefault(_isDevtool);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// 暴露全局的 canvas
GameGlobal.screencanvas = GameGlobal.screencanvas || new _Canvas2.default();
var canvas = GameGlobal.screencanvas;

function getComputedStyle(dom) {
    var tagName = dom.tagName;

    if (tagName === "CANVAS") {
        return (0, _CanvasComputedStyle2.default)(dom);
    } else if (tagName === "IMG") {
        return (0, _ImageComputedStyle2.default)(dom);
    }

    return _CommonComputedStyle2.default;
}

function scrollTo(x, y) {
    // x = Math.min(window.innerWidth, Math.max(0, x));
    // y = Math.min(window.innerHeight, Math.max(0, y));
    // We can't scroll the page of WeChatTinyGame, so it'll always be 0.

    // window.scrollX = 0;
    // window.scrollY = 0;
}

function scrollBy(dx, dy) {
    window.scrollTo(window.scrollX + dx, window.scrollY + dy);
}

function alert(msg) {
    console.log(msg);
}

function focus() {}

function blur() {}

if ((0, _isDevtool2.default)() && swan.getPerformance) {
    var wxPerf = swan.getPerformance();
    var consoleTimers = {};
    console.time = function (name) {
        consoleTimers[name] = wxPerf.now();
    };

    console.timeEnd = function (name) {
        var timeStart = consoleTimers[name];
        if (!timeStart) {
            return;
        }

        var timeElapsed = wxPerf.now() - timeStart;
        console.log(name + ": " + timeElapsed / 1000 + "ms");
        delete consoleTimers[name];
    };
}

function eventHandlerFactory() {
    return function (res) {
        var event = new _Event2.default('resize');

        event.target = window;
        event.timeStamp = Date.now();
        event.res = res;
        event.windowWidth = res.windowWidth;
        event.windowHeight = res.windowHeight;
        document.dispatchEvent(event);
    };
}
// TODO
// swan.onWindowResize(eventHandlerFactory())

var _setTimeout = setTimeout;
var _clearTimeout = clearTimeout;
var _setInterval = setInterval;
var _clearInterval = clearInterval;
var _requestAnimationFrame = requestAnimationFrame;
var _cancelAnimationFrame = cancelAnimationFrame;

exports.canvas = canvas;
exports.alert = alert;
exports.focus = focus;
exports.blur = blur;
exports.getComputedStyle = getComputedStyle;
exports.scrollTo = scrollTo;
exports.scrollBy = scrollBy;
exports.setTimeout = _setTimeout;
exports.clearTimeout = _clearTimeout;
exports.setInterval = _setInterval;
exports.clearInterval = _clearInterval;
exports.requestAnimationFrame = _requestAnimationFrame;
exports.cancelAnimationFrame = _cancelAnimationFrame;